import { renderless, api } from '@opentinyvue/vue-renderless/month-table/vue';
import { defineComponent, $prefix, setup } from '@opentinyvue/vue-common';
import { isDate1 } from '@opentinyvue/utils';
import '@opentinyvue/vue-theme/month-table/index.css';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  name: $prefix + "MonthTable",
  emits: ["changerange", "pick"],
  props: {
    date: {},
    defaultValue: {
      validator: function validator(val) {
        return val === null || isDate1(val) || Array.isArray(val) && val.every(isDate1);
      }
    },
    disabledDate: {
      type: Function,
      default: null
    },
    maxDate: {},
    minDate: {},
    rangeState: {
      default: function _default() {
        return {
          endDate: null,
          selecting: false
        };
      }
    },
    selectionMode: {
      default: "month"
    },
    readonly: {
      type: Boolean,
      default: false
    },
    value: {}
  },
  setup: function setup$1(props, context) {
    return setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("table", {
    staticClass: "tiny-month-table",
    on: {
      "mousemove": _vm.handleMouseMove,
      "click": _vm.handleMonthTableClick
    }
  }, [_c("tbody", _vm._l(_vm.state.rows, function(row, key) {
    return _c("tr", {
      key
    }, _vm._l(row, function(cell, key2) {
      return _c("td", {
        key: key2,
        class: _vm.getCellStyle(cell)
      }, [_c("div", [_c("a", {
        staticClass: "cell",
        domProps: {
          "textContent": _vm._s(_vm.t("ui.datepicker.months." + _vm.state.months[cell.text]))
        }
      })])]);
    }), 0);
  }), 0)]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var MonthTable = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.undefined";
MonthTable.install = function(Vue) {
  Vue.component(MonthTable.name, MonthTable);
};
MonthTable.version = version;

export { MonthTable as default };
